#Paano matuto ng Haskell

Ito ay ang maipapayong daan upang matutunan ang Haskell base sa karanasan na makatutulong sa iba. Mayroong listahang ng mga rekomendasyon sa isa sa mga may akda ng [Haskell Book.](https://haskellbook.com)

## Para sa mga di nag-Iingles

- [In English](README.md)

- [Auf Deutsch](guide-de.md)

- [En Español](guide-es.md)

- [En Français](guide-fr.md)

- [Na Hrvatskom](guide-hr.md)

- [Bahasa Indonesia](guide-id.md)

- [In Italiano](guide-it.md)

- [日本語](guide-ja.md)

- [한국어](guide-ko.md)

- [Em Português](guide-pt.md)

- [În Română](guide-ro.md)

- [По-русски](guide-ru.md)

- [Srpski](guide-sr.md)

- [Türkçe](guide-tr.md)

- [Українською](guide-ua.md)

- [简体中文](guide-zh_CN.md)

- [繁體中文](guide-zh_tw.md)


#### *Wag kang kabahan sa mga bagay na hindi mo naiintindihan agad*. Mag-patuloy ka lamang!

## Komunidad

Ang aming IRC channel ay `#haskell-beginners` sa Freenode.

Kliyenteng pang-websayt [dito](http://webchat.freenode.net/).

Haskell,[listahan ng padadalhan ng sulat](https://wiki.haskell.org/Mailing_lists).

### Patakaran ng Komunidad
Tignan [ang patakaran ng komunidad](coc.md) upang malaman ang adhikain sa IRC channel. Mabibigyan ka ng babala kung hindi ka halatang nanloloko, ngunit maging maingat sapagkat ang channel ay para lamang sa mga gustong matuto o nag-tuturo ng Haskell.

# Pag-iinstall ng Haskell

## Gamitin ang Stack upang makapag simula sa Haskell

I-install ang [Stack](https://haskellstack.org) upang ma-install ang GHC para makapagtayo ng sariling proyekto.

Kung wala kang alam sa kahit ano mang bagay tungkol sa Stack at gustong matuto tungkol dito, tignan itong [unawaan ng Stack bidyo tutorial](https://www.youtube.com/watch?v=sRonIB8ZStw)

## WAG I-INSTALL ANG HASKELL PLATFORM

Datapwa't sundin lamang ang instruksyon sa Haskell.org para makuha ang Stack.

### Bakit hindi ang platform?

https://mail.haskell.org/pipermail/haskell-community/2015-September/000014.html

# Paano ko pag-aaralan ang Haskell?

Ang pinaka-rekomendasyon ay basahin ang mga lektura at tapusin ang mga pagsasanay/takdang aralin para sa Spring 13 version ng cis1940 tapos ang kurso ng FP. Ang dalawa ay naka-takda sa ibaba. Ang iba ay hindi na kailangan ngunit ini-mungkahi para sa iyong kapakanan.

## Haskell Programming from First Principles.

I-Pinapaalam ni [@dmvianna](https://github.com/dmvianna) na ang mga nasa babaya _libreng_ mga rekomendasyon pang-kaalaman. Kung gusto mong tumingin ng libro, inirerekomenda na kumuha ng iyong sariling [Haskell Book](https://haskellbook.com). Kung hindi mo makakayang bilhin ang libro sa anumang dahilan, maaaring mag-sumite saamin ng email gamit ang [aming pahinang pang-suporta](https://haskellbook.com/support.html).

### Ang Haskell Book ay nilalathala ang lahat ng primerong mapagaaralan dito

## Kursong cis1940 ni Yorgey

> *Talakayin muna ito* kung hindi mo bibilhin ang Haskell Book, ito ay ang pinakamagandang _libreng_ introduksyon sa Haskell.

Makukuha [online](https://www.seas.upenn.edu/~cis1940/spring13/lectures.html).

Ang kurso ni [Brent Yorgey](https://byorgey.wordpress.com) ay ang pinakamaganda
sa pagkakaalam ko. Itong kurso ay mahalaga dahil hindi ka lamang tuturuan mag-sulat ng
pinakapundomental na Haskell ngunit matutulungan karin maintindihan ang mga
parser combinators.

Ang tanging dahilan para wag mag-simula sa cis1940 ay kung ikaw ay hindi programmer
o hindi eksperyensado. Kung yun ang kaso, mag-simula sa [Libro ni Thompson](https://www.haskellcraft.com/craft3e/Home.html)
at tyaka lumipat sa cis1940.

---

## Kurso ng Functional Programming

> Ito ang inirerekomenda naming kurso pagkatapos ng Kursong cis1940 ni Yorgey

Makukuha sa [dito](https://github.com/bitemyapp/fp-course) sa github.

Ito ay magbibigay lakas at karanasan sayo sa pag-implementa ng
kabasalan na itinuro sa cis1940, ito ay isang gawi na *kritikal* upang
maing kumportable sa pang-araw araw na pag-gamit ng Functor/Applicative/Monad/etc. sa
Haskell. Ang pag-talakay sa cis1940 at sa FP course ay ang nag-rerepresenta ng ubod
ng rekomendasyon ng aking patnubay at kung paano kami nag-tuturo ng Haskell sa lahat.

---

## Dagdag kurso pagkatapos ng cis1940 at FP course

> Nag-bibigay kaalaman sa mga nakalalalim ng paksa.

Makukuha ang cs240h online:
* [Spring 14](http://www.scs.stanford.edu/14sp-cs240h/)
* [Winter 16](http://www.scs.stanford.edu/16wi-cs240h/)

Ito ay mga online na kurso ni [Bryan O'Sullivan](https://github.com/bos) mula sa
klaseng tinuturuan niya sa Stanford. Kung hindi mo siya kilala, Silyapan lamang
ang kalahati ng aklatan ng kahit anong Haskell application at makikita mo ang kanyang ngalan.
Kung nasagawa mo na ang Kurso ni Yorgey nanduon ang modules sa
phantom types, information flow control, language extensions, concurrency,
pipes, at lenses.

---

# Pang-kaalaman para sa tiyak na paksa sa Haskell

Ang mga mapagkukunan na ito ay hindi tiyak para sa mga nag-aaral di katulad ng cis1940 at FP course, ngunit sila'y linked in [sa listahan ng paksa](specific_topics.md) upang ikaw ay mag-ka ideya kung saan mag-sisimula. Naisasama dito ang mga intermediate/advanced na ideya at paksa katulad ng tooling at text editors.


## Dalwausap

> Naisalagay dito sa repository [dito](dialogues.md).

Ito ay napakamatulungin at importante. Tignan dito para sa mga malalalim na
mga uri ng paksa.
